#!/usr/bin/ruby

require 'pp'

unless ARGV.length == 2
	puts "Remember: ./input_plot_generator.rb <inputFile> <outputDir>"
	exit
end

input = ARGV[0]
output = ARGV[1]

inputFile = IO.readlines(output + "/" + input)
# inputFile = File.open(output + "/" + input,'r')
outputFile = File.open(output + "/" + input + ".formatted",'w')

title = input.gsub(".data","")

outputFile.puts title.gsub("_", " ")

appThreads = title.split("_")[3].gsub("app-threads","").to_i

outputFile.puts (appThreads + 1).to_s


class Record
	attr_accessor :pid, :criticality, :runtime, :futexWaiting, :exitWaiting, :otherWaiting, :concurrentThreads

	def initialize()
		@concurrentThreads = Array.new
	end	
end

input_data = Array.new

i = 0
concGCCritical = 0

while i < inputFile.size

	if not inputFile[i].start_with?("c:")
		rec = Record.new

		split = inputFile[i].split(",")

		if (split[0].eql? "concGCCritical") {
			concGCCritical = split[1].to_i
		} else {
			rec.pid = split[0].to_i
			rec.criticality = split[1].to_i
			rec.runtime = split[2].to_i
			rec.futexWaiting = split[3].to_i
			rec.exitWaiting = split[4].to_i
			rec.otherWaiting = split[5].to_i

			input_data.push(rec)
		}

		i += 1
		while inputFile[i] && inputFile[i].start_with?("c:")  && i < inputFile.size
			rec.concurrentThreads.push(inputFile[i])
			i += 1
		end	
	end
end

# sort input_data
input_data.sort! { |a,b| a.pid <=> b.pid }


# first thread is not a JikesRVM thread
input_data.delete_at(0)


# find iteration number
iteration = title.split("_")[5].to_i

# find names of the threads
threadNamesFile = File.open(output + "/" + title.split("_")[0] + ".threadNames",'r')
threadNamesList = Array.new

includeName = true

threadNamesFile.each do |line|
	if not line.include? "Iteratie"
		if includeName
			threadNamesList.push(line.delete("\n"))
		else
			threadNamesList.push("DO_NOT_INCLUDE")
		end
	else 
		line.gsub!("*","")	
		currentIteration = line.split("_")[1].to_i
		
		if currentIteration == iteration
			includeName = true
		else
			includeName = false
		end
	end
end

# merge threadNames with data
i = 0
j = 0
while i < threadNamesList.size #and j < input_data.size
	if threadNamesList[i] != "DO_NOT_INCLUDE"
		outputFile.puts threadNamesList[i] + "," + input_data[j].criticality.to_s + "," + input_data[j].runtime.to_s + "," + input_data[j].futexWaiting.to_s + "," + input_data[j].exitWaiting.to_s + "," + input_data[j].otherWaiting.to_s 

		input_data[j].concurrentThreads.each { |rec| outputFile.puts rec }

		j += 1
	end
	i += 1
end

outputFile.puts "concGCCritical," + concGCCritical.to_s

threadNamesFile.close
#inputFile.close
outputFile.close

